package collisionDetector.command.evaluator;

public class RowRedEchFormExpr extends Expr
{
	private Expr expr;
	public RowRedEchFormExpr(Expr e)
	{
		expr = e;
	}
	public Expr simplify(EvaluationContext e, int expandOption)
	{
		Expr simple = expr.simplify(e,expandOption);
		if(simple instanceof Matrix)
		{
			return ((Matrix)simple).getRowReducedEchelonForm().simplify(e,expandOption);
		}
		else
		{
			return new RowRedEchFormExpr(simple);
		}
	}
	public void print(int indentlevel)
	{
		printSpaces(indentlevel);
		System.out.println("RowRedEchFormExpr");
		expr.print(indentlevel + 1);
	}
	public String toString(collisionDetector.command.evaluator.EvaluationContext e)
	{
		return "fullRowReduce(" + expr.toString(e) + ")";
	}
			
}

