package collisionDetector.command.evaluator.functions;
import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;
 
public class AbsoluteValue extends Function
{
        public AbsoluteValue(Expr inside)
        {
                super(inside);
        }
        public double getValue(double d, EvaluationContext ec)
        {
                return Math.abs(d);
        }
        public ComplexNumber getValue(ComplexNumber n, EvaluationContext ec)
        {
                return new ComplexNumber(Math.abs(n.getImaginaryValue()),
                                                 Math.abs(n.getRealValue()));
        }
 
        public String getName() { return "abs"; }
		public Expr make(Expr e) { return new AbsoluteValue(e); }
}
