package collisionDetector.command.evaluator.functions;
import collisionDetector.command.evaluator.*;

public class ArcCos extends Function
{
	public ArcCos(Expr inside)
	{
		super(inside);
	}
	public double getValue(double d, EvaluationContext ec)
	{
		return Math.acos(d);
	}
	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec)
	{
		throw new EvaluationException("Imaginary arguments are not supported for this function.");
	}
	public String getName() { return "Arccos"; }
	public Expr make(Expr e) { return new ArcCos(e); }

}
