package collisionDetector.command.evaluator.functions;
import collisionDetector.command.evaluator.*;
public class ArcCosh extends Function
{
	public ArcCosh(Expr inside)
	{
		super(inside);
	}
	public double getValue(double d, EvaluationContext ec)
	{
		//need |x| >= 1
		//TODO:  Throw "value outside of function domain exception"
		//or return imaginary number
		return Math.log(d + Math.sqrt(d*d-1));
	}
	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec)
	{
		throw new EvaluationException("Imaginary arguments are not supported for this function.");
	}
	public String getName() { return "ArcCosh"; }
	public Expr make(Expr e) { return new ArcCosh(e); }
}
