package collisionDetector.command.evaluator.functions;
import collisionDetector.command.evaluator.*;

public class ArcCsch extends Function
{
	public ArcCsch(Expr inside)
	{
		super(inside);
	}
	public double getValue(double d, EvaluationContext ec)
	{
		//x =/= 0
		return Math.log(1/d + Math.sqrt(1+d*d)/Math.abs(d));
	}
	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec)
	{
		throw new EvaluationException("Imaginary arguments are not supported for this function.");
	}
	public String getName() { return "ArcCsch"; }
	public Expr make(Expr e) { return new ArcCsch(e); }

}
