package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.EvaluationException;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class ArcSech extends Function {
	public ArcSech(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		// 0 < x <= 1
		return Math.log((1 + Math.sqrt(1 - d * d)) / d);
	}

	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec) {
		throw new EvaluationException("Imaginary arguments are not supported for this function.");
	}

	public String getName() {
		return "ArcSech";
	}
	public Expr make(Expr e) { return new ArcSech(e); }

}
