package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.EvaluationException;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class ArcSinh extends Function {
	public ArcSinh(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		// -Infinity < x < Infinity
		return Math.log(d + Math.sqrt(d * d + 1));
	}

	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec) {
		throw new EvaluationException("Imaginary arguments are not supported for this function.");
	}
	public Expr make(Expr e) { return new ArcSinh(e); }

	public String getName() {
		return "ArcSinh";
	}
}
