package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.EvaluationException;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class ArcTan extends Function {
	public ArcTan(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return Math.atan(d);
	}

	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec) {
		throw new EvaluationException("Imaginary arguments are not supported for this function.");
	}
	public Expr make(Expr e) { return new ArcTan(e); }

	public String getName() {
		return "Arctan";
	}
}
