package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class Cos extends Function {
	public Cos(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return Math.cos(d);
	}

	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec) {
		return new ComplexNumber(cosh(c.getImaginaryValue(), null) * Math.cos(c.getRealValue()), -1
				* Math.sin(c.getRealValue()) * sinh(c.getImaginaryValue(), null));
	}

	public String getName() {
		return "Cos";
	}
	public Expr make(Expr e) { return new Cos(e); }

}
