package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class Cosh extends Function {
	public Cosh(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return (Math.exp(d) + Math.exp(-d)) / 2;
	}

	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec) {
		return new ComplexNumber(cosh(c.getRealValue(), null) * Math.cos(c.getImaginaryValue()), sinh(c.getRealValue(),
				null)
				* Math.sin(c.getImaginaryValue()));
	}
	public Expr make(Expr e) { return new Cosh(e); }

	public String getName() {
		return "cosh";
	}

}
