package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class Cot extends Function {
	public Cot(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return 1 / Math.tan(d);
	}

	public ComplexNumber getValue(ComplexNumber n, EvaluationContext ec) {
		ComplexNumber cosPart = new ComplexNumber(cosh(n.getImaginaryValue(), null) * Math.cos(n.getRealValue()), -1
				* Math.sin(n.getRealValue()) * sinh(n.getImaginaryValue(), null));
		ComplexNumber sinPart = new ComplexNumber(cosh(n.getImaginaryValue(), null) * Math.sin(n.getRealValue()), Math
				.cos(n.getRealValue())
				* sinh(n.getImaginaryValue(), null));
		return cosPart.divide(sinPart);
	}

	public String getName() {
		return "cot";
	}
	public Expr make(Expr e) { return new Cot(e); }

}
