package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.EvaluationException;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class Coth extends Function {
	public Coth(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return (Math.exp(d) + Math.exp(-d)) / (Math.exp(d) - Math.exp(-d));
	}

	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec) {
		throw new EvaluationException("Not implemented yet.");
	}

	public String getName() {
		return "coth";
	}
	public Expr make(Expr e) { return new Coth(e); }

}
