package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;
import collisionDetector.command.evaluator.NumberExpr;

public class Csc extends Function {
	public Csc(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return 1 / Math.sin(d);
	}

	public ComplexNumber getValue(ComplexNumber n, EvaluationContext ec) {
		ComplexNumber sinPart = new ComplexNumber(cosh(n.getImaginaryValue(), null) * Math.sin(n.getRealValue()), Math
				.cos(n.getRealValue())
				* sinh(n.getImaginaryValue(), null));
		return (ComplexNumber) NumberExpr.ONE.divide(sinPart);
	}

	public String getName() {
		return "csc";
	}
	public Expr make(Expr e) { return new Csc(e); }

}
