package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.EvaluationException;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class Csch extends Function {
	public Csch(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return 2 / (Math.exp(d) - Math.exp(-d));
	}

	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec) {
		throw new EvaluationException("Imaginary arguments are not supported for this function.");
	}

	public String getName() {
		return "csch";
	}

	public Expr make(Expr e) { return new Csch(e); }
}
