package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class Ln extends Function {
	public Ln(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return Math.log(d);
	}

	public ComplexNumber getValue(ComplexNumber c, EvaluationContext ec) {
		double realPart = Math.log(c.getMagnitude().getRealValue());
		double imagPart = Math.atan(c.getImaginaryValue() / c.getRealValue());
		return new ComplexNumber(realPart, imagPart);
	}

	public String getName() {
		return "ln";
	}
	public Expr make(Expr e) { return new Ln(e); }

}
