package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;
import collisionDetector.command.evaluator.NumberExpr;

public class Sec extends Function {
	public Sec(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return 1 / Math.cos(d);
	}

	public ComplexNumber getValue(ComplexNumber n, EvaluationContext ec) {
		ComplexNumber cosPart = new ComplexNumber(cosh(n.getImaginaryValue(), null) * Math.cos(n.getRealValue()), -1
				* Math.sin(n.getRealValue()) * sinh(n.getImaginaryValue(), null));
		return (ComplexNumber) NumberExpr.ONE.divide(cosPart);
	}
	public Expr make(Expr e) { return new Sec(e); }

	public String getName() {
		return "sec";
	}
}
