package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class Sin extends Function {
	public Sin(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return Math.sin(d);
	}

	public ComplexNumber getValue(ComplexNumber n, EvaluationContext ec) {
		return new ComplexNumber(cosh(n.getImaginaryValue(), null) * Math.sin(n.getRealValue()), Math.cos(n
				.getRealValue())
				* sinh(n.getImaginaryValue(), null));
	}

	public String getName() {
		return "sin";
	}

	public Expr make(Expr e) {
		return new Sin(e);
	}

}
