package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class Sinh extends Function {
	public Sinh(Expr inside) {
		super(inside);
	}

	public double getValue(double d, EvaluationContext ec) {
		return (Math.exp(d) - Math.exp(-d)) / 2;
	}

	public ComplexNumber getValue(ComplexNumber n, EvaluationContext ec) {
		return new ComplexNumber(sinh(n.getRealValue(), null) * Math.cos(n.getImaginaryValue()), cosh(n.getRealValue(),
				null)
				* Math.sin(n.getImaginaryValue()));
	}

	public String getName() {
		return "sinh";
	}
	public Expr make(Expr e) { return new Sinh(e); }

}
