package collisionDetector.command.evaluator.functions;

import collisionDetector.command.evaluator.ComplexNumber;
import collisionDetector.command.evaluator.EvaluationContext;
import collisionDetector.command.evaluator.Expr;
import collisionDetector.command.evaluator.Function;

public class Tan extends Function {
	public Tan(Expr inside) {
		super(inside);
	}

	public double getValue(double v, EvaluationContext ec) {
		return Math.tan(v);
	}

	public ComplexNumber getValue(ComplexNumber n, EvaluationContext ec) {
		ComplexNumber cosPart = new ComplexNumber(cosh(n.getImaginaryValue(), null) * Math.cos(n.getRealValue()), -1
				* Math.sin(n.getRealValue()) * sinh(n.getImaginaryValue(), null));
		ComplexNumber sinPart = new ComplexNumber(cosh(n.getImaginaryValue(), null) * Math.sin(n.getRealValue()), Math
				.cos(n.getRealValue())
				* sinh(n.getImaginaryValue(), null));
		return sinPart.divide(cosPart);
	}
	public Expr make(Expr e) { return new Tan(e); }

	public String getName() {
		return "Tan";
	}
}
