package collisionDetector.detector;

import collisionDetector.detector.interfaces.ICollidor;
import collisionDetector.detector.interfaces.IDetector;
import collisionDetector.detector.motionCreator.IMotionCreator;
import collisionDetector.detector.reciever.IReceiver;
import collisionDetector.detector.reciever.RawFrame;
import collisionDetector.main.dataStructures.List;
import collisionDetector.main.interfaces.IMyRunnerCallback;
import collisionDetector.main.util.ContextChecker;

public class Detector implements IDetector {

	IReceiver iReceiver;
	IMotionCreator iMotionCreator;
	ICollidor iCollidor;
	
	IMyRunnerCallback iMyRunner;
	
	
	public int size;
	
	float rd_goodVoxelSize;
	
	
	public Detector(final float goodVoxelSize) {
		// TODO Auto-generated constructor stub
		
		rd_goodVoxelSize = goodVoxelSize;
		
		
		
	}
	
	
	public void bindRunner(IMyRunnerCallback i) {
		iMyRunner = i;
	}
	
	
	
	
	///////////////////////////////////////////////////////////////////////////////////
	
	
	public void detect() {
		
		//final Reducer_2 r = new Reducer_2(rd_);
    //final StateTable_2 st = new StateTable_2();
    //st.table = state;
    //final List collisions = lookForCollisions(r, st.createMotions(f_));
    //size = collisions.size();
		
		System.out.println("[Detector]");
		ContextChecker.checkContext(ContextChecker.SCOPE_CONTEXT);
		
		
		
		
    RawFrame frame = iReceiver.receive();
    
    
    if (frame == null ) {
    	// no frames, we are done
    	iMyRunner.stopMyRunner();
    	return;
    }
    frame.print();
    
    System.out.println("[Detector] A rawFrame obtained...");
  
    
    
    
    List motions = iMotionCreator.createMotions(frame);
    System.out.println("motions:" + motions.size());
    
    
    List collisionList = iCollidor.lookForCollisions(motions);
    
    
    
    //TODO: proceed the list of collisions
    size = collisionList.size();
    // Ales
    System.out.println("printing result size:" + size);
	}


	
	
	
	
	public IReceiver getReceiver() {
		// TODO Auto-generated method stub
		return iReceiver;
	}


	public void bindReceiver(IReceiver receiver) {
		iReceiver = receiver;
	}


	public void bindMotionCreator(IMotionCreator motionCreat) {
	  iMotionCreator  = motionCreat;
	}


	public void bindCollidor(ICollidor coll) {
		iCollidor = coll;
	}
	
	
	

}
