package collisionDetector.detector;


import javax.realtime.LTMemory;



import collisionDetector.detector.interfaces.IDetector;
import collisionDetector.main.util.ContextChecker;


class DetectorLogic implements Runnable {
	IDetector detector;
	
	DetectorLogic(IDetector detec) {
		detector = detec;
	}
	
	public void run() {
		ContextChecker.checkContext(ContextChecker.SCOPE_CONTEXT);
		
		detector.detect();
	}
	
	
}


public class DetectorInterceptor implements IDetector {
   
	
	
	LTMemory scopedMemory;
	IDetector detector;
	DetectorLogic logic;
	
	DetectorInterceptor(IDetector detec) {
  	detector = detec;
  	scopedMemory = new LTMemory(8*1024); 
  	
  	logic = new DetectorLogic(detec);
  }
	
	
	
	public void detect() {
		scopedMemory.enter(logic);		
	}

}
