package collisionDetector.detector.motionCreator;


import collisionDetector.detector.reciever.RawFrame;
import collisionDetector.main.dataStructures.CallSign;
import collisionDetector.main.dataStructures.HashSet;
import collisionDetector.main.dataStructures.LinkedList;
import collisionDetector.main.dataStructures.List;
import collisionDetector.main.dataStructures.Vector3d;
import collisionDetector.main.dataStructures.Aircraft;
import collisionDetector.main.interceptor.IStateTable;

public class MotionCreator implements IMotionCreator {

	 Aircraft craft;
   Vector3d new_pos;	
   IStateTable iStateTable;
   
   
	/**
	 * 
	 * 
	 * 
	 */
	public List createMotions(RawFrame f) {


		//System.out.println("Creating motions...");
		
		
		final List ret = new LinkedList();
    final HashSet poked = new HashSet();
    
    for (int i = 0, pos = 0; i < f.planeCnt; i++) {
        
    	final float x = f.positions[i], y = f.positions[i + 1], z = f.positions[i + 2];
        final byte[] cs = new byte[f.lengths[i]];
        for (int j = 0; j < cs.length; j++)
            cs[j] = f.callsigns[pos + j];
        
        pos += cs.length;
        
        // Ales: I had to change these two variables as locals, before 
        //  they were attributes of this class
        Aircraft craft = new Aircraft(cs);
        Vector3d new_pos = new Vector3d(x, y, z);
        poked.add(craft);        
        
        final Vector3d old_pos = (Vector3d) iStateTable.getOldAirCraftPosition(craft);
        if (old_pos == null) {
        	iStateTable.put(mkCallsign(craft.getCallsign()), new_pos.x, new_pos.y, new_pos.z);
          ret.add(new Motion(craft, new_pos));
          System.out.println("new aircraft.....");
        } else {
            //TODO: the problem is maybe here... we are updating the new position
        	  // but we are in the scope, we should call the iStateTable again...
        	
        	final Vector3d save_old_position = new Vector3d(old_pos.x, old_pos.y, old_pos.z);
          
        	//old_pos.set(new_pos.x, new_pos.y, new_pos.z);
        	
        	iStateTable.updatePosition(mkCallsign(craft.getCallsign()),new_pos.x, new_pos.y, new_pos.z);
        	
          ret.add(new Motion(craft, save_old_position, new_pos));
          
          
          System.out.println("Updating Positions.....");
          
        }
        
    }
    
    return ret;
		
		
	}

	
	private CallSign mkCallsign(final byte[] cs) {
    return iStateTable.getCallSign(cs);
  }


	public void bindTable(IStateTable table) {
		iStateTable = table;
		System.out.println("Creating motions..bind statetable.");
	}
	
	
	
	
	
	
}
