package collisionDetector.detector.reciever;




import collisionDetector.main.data.Constants;
import collisionDetector.main.util.ContextChecker;


public class Receiver implements IReceiver {

	
	static int framesProcessed;
  static final private int MAX_FRAMES = 100;
  public static int first, last;
  public static final RawFrame[] frames = new RawFrame[MAX_FRAMES];
	
	//TODO some initialization, but is it correct?
	public Receiver() {
		for (int i = 0; i < MAX_FRAMES; i++)
       frames[i] = new RawFrame();
	}
	
	
	

	
	 public RawFrame receive() {
    
		 // checking if we have already processed all the frames
		 if (framesProcessed++ == Constants.MAX_FRAMES) 
    	 return null;
		 
     System.out.println("Receiving a frame...");
     
		 
		 if (last == first) { 
			 System.out.println("No frame available: " + last + " first:"+ first);
			 return null;
		 }
     else {
         final int f = first;
         first = (first + 1) % MAX_FRAMES;
         return frames[f];
     }
   }
	 
	 
	 
	 
	 public void sendFromPJ(final float[] positions_, final int[] lengths_, final byte[] callsigns_) {
     
		 System.out.println("[Receiver] Simulator generates a frame...");
		 
		 System.out.println("[Receiver] Checking heap context ...");
		 ContextChecker.checkContext(ContextChecker.HEAP_CONTEXT);
		 ContextChecker.checkContext(ContextChecker.SE_THREAD);
		 
		 
		 if (last + 1 == first) {
			 return; // dropping frame
		 }
		 
		 
		 System.out.println("storing the frame...");
		 frames[last].copy(lengths_, callsigns_, positions_);
		 frames[last].print();
		 synchronized (this) {
         last = (last + 1) % MAX_FRAMES;
     }
     
     System.out.println("last=" + last + " first:" + first);
 }
	 
	
}
