package collisionDetector.main;

import javax.realtime.ImmortalMemory;
import javax.realtime.LTMemory;
import javax.realtime.MemoryArea;
import javax.realtime.PeriodicParameters;
import javax.realtime.PriorityParameters;
import javax.realtime.RealtimeThread;
import javax.realtime.RelativeTime;
import javax.realtime.WaitFreeWriteQueue;

import collisionDetector.detector.Detector;
import collisionDetector.detector.reciever.IReceiver;
import collisionDetector.main.data.Constants;
import collisionDetector.main.interceptor.StateTableInterceptor;
import collisionDetector.main.util.ContextChecker;
import collisionDetector.simulator.MySimulator;
import collisionDetector.simulator.SerializedFrame;





public class Main {

	static ImmortalAllocation immAlloc;
	static final int CONST_FRAMES = 100;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
	 
		/*
		// instantiating the immortal component
		MyRunner myRunner = allocInImmortal();
		
	
		System.out.println("immAlloc" + immAlloc.iReceiver);
		
		SerializedFrame[] frames = new SerializedFrame[CONST_FRAMES];
		MySimulator.generate(args,frames,immAlloc.iReceiver);
	
		
		
		
		myRunner.start();
		*/
		
		CollisionDetector collisionDetector = new CollisionDetector();
		collisionDetector.init(args);
		collisionDetector.start();
		
	}

	







	
	/**
	 * Ales
	 * 
	 * 
	 * 
	 * instantiating the immortal component - productionLine
	 * 
	 * 
	 * @return
	 */
	/*
	private static MyRunner allocInImmortal() {
	
		// runnable thread containing the logic (instantiation proceedures) that has to be
		// executed in the immortal memory
		immAlloc = new ImmortalAllocation();
	
		//realtime thread working in immortal memory
		// - this thread do the instantiation - it will execute the immAlloc thread 
		RealtimeThread rt = new RealtimeThread(null, null, null, ImmortalMemory
				.instance(), // Start the thread in immortal
				null, immAlloc);
		// running the instantiation
		rt.start();
	
		//TODO: waiting until the instantiation will finish - here will be a problem on truly real-time machines
		try {
			RealtimeThread.sleep(2000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
	
			e.printStackTrace();
		}
		//System.out.println("Checking the immortal allocation result (should be non null):"+ immAlloc.productionLine);
	
		if (immAlloc.exception != null) {
			System.out.println("ERROR: exception thrown during intialization.");
			System.out.println("Exception:" + immAlloc.exception.toString() + "    "
					+ immAlloc.exception.getMessage());
			immAlloc.exception.printStackTrace();
	
			return null;
		}
	
		if (!(MemoryArea.getMemoryArea(immAlloc.runner) instanceof ImmortalMemory)) {
			System.out.println("ERROR: Runner is NOT in immortal.");
			System.out.println("Is in: "
					+ MemoryArea.getMemoryArea(immAlloc.runner));
			return immAlloc.runner;
		}
	
		System.out.println("Runner is immortal, instantiation... OK.");
		return immAlloc.runner;
	}
*/


}

/*
class ImmortalAllocation implements Runnable {

  public MyRunner runner = null;
  public IReceiver iReceiver = null;
 
	public Exception exception = null;

	//
	// just some logic for printing on Console when being in immortal - since its not so trivial...
	//
	final LTMemory scopedA = new LTMemory(8 * 1024);
	Runnable runTh = new Runnable() {
		public void run() {
			//System.out.println("Mem Consumed " + scopedA.memoryConsumed());
			//System.out.println("immortal memory consumed " + ImmortalMemory.instance().memoryConsumed()  );
			System.out.println("Mem Consumed " + scopedA.memoryConsumed());
			System.out.println("immortal memory consumed "
					+ ImmortalMemory.instance().memoryConsumed());
		}
	};

	private void memConsumed() {
		scopedA.enter(runTh);
	}

	public void run() {

		try {

			memConsumed();

		

			ContextChecker.checkContext(ContextChecker.IMMORTAL_CONTEXT);
			//ContextChecker.checkContext(ContextChecker.NHRT_THREAD);
			
			
		
	    
			runner = new MyRunner(new PriorityParameters(Constants.PRIORITY), new PeriodicParameters(null,// start
	        new RelativeTime(Constants.PERIOD, 0),// period
	        null,// new RelativeTime(5,0),//cost
	        null,// new RelativeTime(50,0),//deadline
	        null, null), ImmortalMemory.instance());
			
			
			Detector detector = new Detector(Constants.GOOD_VOXEL_SIZE);
			detector.bindRunner(runner);
			
			System.out.println("Runner is:");
			
			StateTable table = new StateTable();
			
			
			
			StateTableInterceptor tableInterceptor = new StateTableInterceptor(table);
			detector.bindTable(tableInterceptor);
			

			
			
			iReceiver = detector.getReceiver();
			
		
			memConsumed();


		} catch (Exception e) {
			//throw new org.objectweb.fractal.julia.factory.ChainedInstantiationException(e,null,e.getClass().getName()+": "+e.getMessage());
			exception = e;

		}
	}

}
*/
