package collisionDetector.main;




import collisionDetector.main.dataStructures.Aircraft;
import collisionDetector.main.dataStructures.CallSign;
import collisionDetector.main.dataStructures.HashMap;
import collisionDetector.main.dataStructures.Vector3d;
import collisionDetector.main.interceptor.IStateTable;
import collisionDetector.main.util.ContextChecker;

/**
 * 
 * 
 * 
 * @author Filip Pizlo, Ales Plsek
 *
 */
public class StateTable implements IStateTable {

	final private int MAX = 10000;
  Vector3d[] vals;
  private int count = 0;

  /** Stores the previous state by mapping Aircraft -> Vector3d. */
  final HashMap previous_state = new HashMap();
	
	public StateTable() {
    vals = new Vector3d[MAX];
    for (int i = 0; i < vals.length; i++)
        vals[i] = new Vector3d();
    System.out.println("State table INITIALIZATION:" + "count:" + count + previous_state.size());
    ContextChecker.checkContext(ContextChecker.IMMORTAL_CONTEXT);
		//ContextChecker.checkContext(ContextChecker.NHRT_THREAD);
	}
	
	
	
	
	
	
	public void put(final CallSign callsign, final float x, final float y, final float z) {
    Vector3d v = (Vector3d) previous_state.get(callsign);
    if (v == null) {
        v = vals[count++]; // What if we exceed MAX?
        previous_state.put(callsign, v);
        
        System.out.println("State table put: INCREASING" + "count:" + count + previous_state.size());
    }
    v.x = x;
    v.y = y;
    v.z = z;
    
    System.out.println("State table put:" + "count:" + count + previous_state.size());
    ContextChecker.checkContext(ContextChecker.IMMORTAL_CONTEXT);
	}






	public Vector3d getOldAirCraftPosition(Aircraft craft) {
		return (Vector3d) previous_state.get(craft);
		//return null;
	}
	
	
	
	public CallSign getCallSign(final byte[] cs) {
			
		final byte[] b = new byte[cs.length];
    for (int i = 0; i < b.length; i++)
        b[i] = cs[i];
   
    return new CallSign(b);
		
	}
	
	public void updatePosition(final CallSign callsign, final float x, final float y, final float z) {
		Vector3d v = (Vector3d) previous_state.get(callsign);
    if (v == null) {
      // this should not happen, the aircraft should be already there
    	// should never reach this.  
    	System.out.println("ERROR");
    }
    v.x = x;
    v.y = y;
    v.z = z;
    
    System.out.println("Updating Positions.....");
    
	}
	
	
}
