package collisionDetector.main.interceptor;

import javax.realtime.LTMemory;



import collisionDetector.detector.interfaces.IDetector;
import collisionDetector.main.data.Constants;

public class DetectorInterceptor implements IDetector {

	
	LTMemory detectorScope;
	Runnable scopeRunnable;
	
	
	public DetectorInterceptor(IDetector iDetector) {
		detectorScope = new LTMemory(Constants.CDMEM_SIZE, Constants.CDMEM_SIZE);
		scopeRunnable =  new InterceptorRunnable(iDetector);	
	}
	
	
	/**
	 * 
	 * 
	 *  
	 */
	public void detect() {
		
  	detectorScope.enter(scopeRunnable);
		
		

	}

}







class InterceptorRunnable implements Runnable {
	public IDetector iDetector;
	
	public InterceptorRunnable(IDetector iDetec) {
		iDetector = iDetec;
	}
	
	public void run() {
		iDetector.detect();
	}
};