package collisionDetector.main.interceptor;



import javax.realtime.ImmortalMemory;
import collisionDetector.main.dataStructures.Aircraft;
import collisionDetector.main.dataStructures.CallSign;
import collisionDetector.main.dataStructures.Vector3d;


/** 
 * 
 * 
 * 
 * 
 */
public class StateTableInterceptor implements IStateTable {

	IStateTable iStateTable;
	
	private CallSignRunnable callSignRunnable;
	
	/** 
	 * 
	 */
	public StateTableInterceptor(IStateTable table) {
		iStateTable = table;
	}
	
	
	/** 
	 * will allocate the CallSign in the memory of the StateTable
	 */
	public CallSign getCallSign(final byte[] cs) {
		
		//System.out.println("[StateTableInterceptor] getCallSign");
		
		
		CallSignRunnable callSignRunnable = new CallSignRunnable();
		callSignRunnable.cs = cs;
		
		//TODO: generally we should be independent from the memory area,
		// this interceptor should have a reference to a memory area 
		// into which we want to enter...
		//ScopedMemory.getMemoryArea(table).executeInArea(r);
		ImmortalMemory.instance().executeInArea(callSignRunnable);
		return callSignRunnable.callSign;
	}

	
	/** 
	 * 
	 */
	public Vector3d getOldAirCraftPosition(Aircraft craft) {
		
		//System.out.println("[StateTableInterceptor] get old aircraft");
		
		
		return iStateTable.getOldAirCraftPosition(craft);
	}

	
	/** 
	 * 
	 */
	public void put(CallSign callsign, float x, float y, float z) {
		
		//System.out.println("[StateTableInterceptor] put aircraft");
		
		
		putInStateTable(callsign,x,y,z);
	}

	
	/**
	 * 
	 * we have to allocate it in the memory into which we are going to enter
	 * 
	 * @param cs
	 * @return
	 */
	private byte[] copy(final byte[] cs) {
		
		//ImmortalMemory.instance().
		final byte[] res = new byte[cs.length];
    for (int i = 0; i < cs.length; i++)
        res[i] = cs[i];
		return res;
	}	


	
	
	static class CallSignRunnable implements Runnable{
		
		CallSign callSign;
	  byte[] cs;

	  public void run() {
	      final byte[] b = new byte[cs.length];
	      for (int i = 0; i < b.length; i++)
	          b[i] = cs[i];
	      //storing the callSign in the runnable
	      callSign = new CallSign(b);
	  }
		
	}
	
	
 
	PutRunnable r = new PutRunnable();
	 
	 
	 public void putInStateTable(final CallSign callsign, final float x, final float y, final float z) {
     
		 PutRunnable r = new PutRunnable();
		 r.callsign = callsign;
     r.x = x;
     r.y = y;
     r.z = z;
     //ScopedMemory.getMemoryArea(this).executeInArea(r);
     ImmortalMemory.instance().executeInArea(r);
	 }
	
	 public void updatePosition(final CallSign callsign, final float x, final float y, final float z) {
     
		 UpdateRunnable r = new UpdateRunnable();
		 r.callsign = callsign;
     r.x = x;
     r.y = y;
     r.z = z;
     //ScopedMemory.getMemoryArea(this).executeInArea(r);
     ImmortalMemory.instance().executeInArea(r);
	 }
	
	 
	 
	 
	 
	 
	 
	 private class PutRunnable implements Runnable {
     CallSign callsign;
     float x, y, z;

     public void run() {
    	 iStateTable.put(callsign,x,y,z);
     }
	 }
	 
	 
	 private class UpdateRunnable implements Runnable {
     CallSign callsign;
     float x, y, z;

     public void run() {
    	 iStateTable.updatePosition(callsign,x,y,z);
     }
	 }
}


